package com.nokia.financeapi.pojo.vo;

import io.swagger.v3.oas.annotations.Hidden;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

@NoArgsConstructor
@Data
public class GetBuildingAreaDiffVo {
    @Hidden
    private String areaName;
    @Hidden
    private String cityName;
    @Schema(description = "单位名称", example = "全省")
    private String unitName;
    @Schema(description = "上年建筑面积", example = "3345429.01")
    private BigDecimal buildingAreaSumLast;
    @Schema(description = "上年建筑面积自用", example = "3345429.01")
    private BigDecimal buildingAreaSelfUseSumLast;
    @Schema(description = "上年建筑面积闲置", example = "3345429.01")
    private BigDecimal buildingAreaIdleSumLast;
    @Schema(description = "当月建筑面积", example = "3345429.01")
    private BigDecimal buildingAreaSumNow;
    @Schema(description = "当月建筑面积自用", example = "3345429.01")
    private BigDecimal buildingAreaSelfUseSumNow;
    @Schema(description = "当月建筑面积闲置", example = "3345429.01")
    private BigDecimal buildingAreaIdleSumNow;
    @Schema(description = "建筑面积变化%", example = "12.34")
    private BigDecimal buildingAreaDiff;
    @Schema(description = "自用面积变化%", example = "12.34")
    private BigDecimal buildingAreaSelfUseDiff;
    @Schema(description = "闲置面积变化%", example = "-12.34")
    private BigDecimal buildingAreaIdleDiff;
    @Schema(description = "子列表")
    private List<GetBuildingAreaDiffVo> children;
}
